
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Recognition_postsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const recognition_posts = await db.recognition_posts.create(
            {
                id: data.id || undefined,
        
        recognition_type: data.recognition_type
        ||
        null
            ,
            
        message: data.message
        ||
        null
            ,
            
        points_awarded: data.points_awarded
        ||
        null
            ,
            
        coins_awarded: data.coins_awarded
        ||
        null
            ,
            
        posted_at: data.posted_at
        ||
        null
            ,
            
        is_public: data.is_public
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await recognition_posts.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await recognition_posts.setFrom_user( data.from_user || null, {
            transaction,
        });
        
        await recognition_posts.setTo_user( data.to_user || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.recognition_posts.getTableName(),
                belongsToColumn: 'media_images',
                belongsToId: recognition_posts.id,
            },
            data.media_images,
            options,
        );
        

        return recognition_posts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const recognition_postsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                recognition_type: item.recognition_type
            ||
            null
            ,
            
                message: item.message
            ||
            null
            ,
            
                points_awarded: item.points_awarded
            ||
            null
            ,
            
                coins_awarded: item.coins_awarded
            ||
            null
            ,
            
                posted_at: item.posted_at
            ||
            null
            ,
            
                is_public: item.is_public
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const recognition_posts = await db.recognition_posts.bulkCreate(recognition_postsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < recognition_posts.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.recognition_posts.getTableName(),
                    belongsToColumn: 'media_images',
                    belongsToId: recognition_posts[i].id,
                },
                data[i].media_images,
                options,
            );
        }
        

        return recognition_posts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const recognition_posts = await db.recognition_posts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.recognition_type !== undefined) updatePayload.recognition_type = data.recognition_type;
        
        
        if (data.message !== undefined) updatePayload.message = data.message;
        
        
        if (data.points_awarded !== undefined) updatePayload.points_awarded = data.points_awarded;
        
        
        if (data.coins_awarded !== undefined) updatePayload.coins_awarded = data.coins_awarded;
        
        
        if (data.posted_at !== undefined) updatePayload.posted_at = data.posted_at;
        
        
        if (data.is_public !== undefined) updatePayload.is_public = data.is_public;
        
        
        updatePayload.updatedById = currentUser.id;

        await recognition_posts.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await recognition_posts.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.from_user !== undefined) {
            await recognition_posts.setFrom_user(
              
              data.from_user,
              
              { transaction }
            );
        }
        
        if (data.to_user !== undefined) {
            await recognition_posts.setTo_user(
              
              data.to_user,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.recognition_posts.getTableName(),
                belongsToColumn: 'media_images',
                belongsToId: recognition_posts.id,
            },
            data.media_images,
            options,
        );
        

        return recognition_posts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const recognition_posts = await db.recognition_posts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of recognition_posts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of recognition_posts) {
                await record.destroy({transaction});
            }
        });


        return recognition_posts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const recognition_posts = await db.recognition_posts.findByPk(id, options);

        await recognition_posts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await recognition_posts.destroy({
            transaction
        });

        return recognition_posts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const recognition_posts = await db.recognition_posts.findOne(
            { where },
            { transaction },
        );

        if (!recognition_posts) {
            return recognition_posts;
        }

        const output = recognition_posts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await recognition_posts.getOrganization({
            transaction
        });
        
        
        output.from_user = await recognition_posts.getFrom_user({
            transaction
        });
        
        
        output.to_user = await recognition_posts.getTo_user({
            transaction
        });
        
        
        output.media_images = await recognition_posts.getMedia_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.users,
        as: 'from_user',
        
        where: filter.from_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.from_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.from_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'to_user',
        
        where: filter.to_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.to_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.to_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'media_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'recognition_posts',
                        'message',
                        filter.message,
                    ),
                };
            }
            

            
            

            
            if (filter.points_awardedRange) {
                const [start, end] = filter.points_awardedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    points_awarded: {
                    ...where.points_awarded,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    points_awarded: {
                    ...where.points_awarded,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.coins_awardedRange) {
                const [start, end] = filter.coins_awardedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    coins_awarded: {
                    ...where.coins_awarded,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    coins_awarded: {
                    ...where.coins_awarded,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.posted_atRange) {
                const [start, end] = filter.posted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    posted_at: {
                    ...where.posted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    posted_at: {
                    ...where.posted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.recognition_type) {
                where = {
                    ...where,
                recognition_type: filter.recognition_type,
            };
            }
            
            if (filter.is_public) {
                where = {
                    ...where,
                is_public: filter.is_public,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.recognition_posts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'recognition_posts',
                        'message',
                        query,
                    ),
                ],
            };
        }

        const records = await db.recognition_posts.findAll({
            attributes: [ 'id', 'message' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['message', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.message,
        }));
    }

    
};

